package jadex.bdi.testcases;

import jadex.base.IPlatformConfiguration;
import jadex.base.Starter;
import jadex.base.test.util.STest;
import jadex.bridge.IExternalAccess;
import jadex.bridge.IInternalAccess;
import jadex.bridge.SFuture;
import jadex.bridge.service.annotation.OnStart;
import jadex.bridge.service.types.cms.CreationInfo;
import jadex.commons.future.SubscriptionIntermediateFuture;
import jadex.micro.annotation.Agent;

/**
 *  Test if timers are removed after agent death.
 */
@Agent
public class TimerTestAgent
{
	@OnStart
	public void	body(IInternalAccess access)
	{
		SFuture.getNoTimeoutFuture(SubscriptionIntermediateFuture.class, access);
	}
	
	public static void main(String[] args)
	{
		IPlatformConfiguration	config	= STest.getDefaultTestConfig(TimerTestAgent.class.getName());
		IExternalAccess	platform	= Starter.createPlatform(config).get();
		IExternalAccess	agent	= platform.createComponent(new CreationInfo().setFilenameClass(TimerTestAgent.class)).get();
		System.out.println("+++++ before kill");
		agent.waitForDelay(10000).get();
		agent.killComponent().get();
		System.out.println("+++++ after kill");
	}
}
